/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg;

import java.util.List;
import java.util.Comparator;

/**
 *
 * @author omozegieaziegbe
 */
public class ClosestNumberFinderStream {
    
    public static int findClosestNumberStream(List<Integer> numbers, int target) {
        return numbers.stream()
                .min(Comparator.comparingInt(num -> Math.abs(num - target)))
                .orElseThrow(() -> new IllegalArgumentException("List cannot be empty"));
    }

    public static void main(String[] args) {
        List<Integer> numbers = List.of(-10, 2, 4, 8, 15); 
        int target = 5; 
        int result = findClosestNumberStream(numbers, target);
        System.out.println("Closest number to " + target + " is: " + result);
    }
}
